#ifndef FONT_H_INC
#define FONT_H_INC

namespace GameLib
{ class CDDraw;
  class CDDSurface;
}
class CVFS;

// this code is not finished
struct Font
{ Font() { Surf.Deinit(); }
  // return the dimensions of the string passed when written with this Font
  void StringDims (const char *str, int *wid, int *hei=NULL)
  { StringDims(str, strlen(str), wid, hei); }
  // ditto, but takes the length of the string
  void StringDims (const char *, int len, int *wid, int *hei=NULL);
  // ditto, but the string uses PrintF syntax
  void StringDimsF(int *wid, int *hei, const char *, ...);
  // print a string with a font in the given color
  void Print (GameLib::CDDSurface *, const char *,
              int x, int y, GameLib::CDDColor c);
  // print a string with a font in the given color, clipped to the given rect
  void Print (GameLib::CDDSurface *, const char *,
              RECT *, GameLib::CDDColor c);
  // ditto, but uses printf syntax
  void PrintF(GameLib::CDDSurface *, int x, int y,
              GameLib::CDDColor c, const char *, ...);
  void PrintF(GameLib::CDDSurface *, RECT *, GameLib::CDDColor c,
              const char *, ...);

  GameLib::CDDSurface Surf;            // surface holding the font image
  int                 FontHei, AvgWid; // maximum character height and average width
  RECT                Places[95];      // rectangles of the font characters
};


class CFont
{ public:
    CFont();

    // init the font system.. VFS is the VFS to read fonts from
    void Init(GameLib::CDDraw *, CVFS *);

    // load a font from the VFS into the Font
    int  LoadFont(const char *name, Font *);

  protected:
    GameLib::CDDraw *Cddraw;
    CVFS            *VFS;
};

#endif
