#ifndef SHIP_H_INC
#define SHIP_H_INC

#include "GameObj.h"
#include "IntrFace\Prims2D.h"
#include "Weapons.h"

enum GunPos
{ GP_GUN, GP_SPECIAL, GP_NUM, GP_UNKNOWN
};

struct MsgNewObject;

class ShipObj : public SphereObj
{ public:
    ShipObj();
    ShipObj(int x, int y) : SphereObj(x, y, 9) { Init(); }
    virtual ~ShipObj();

    virtual void Draw(int x, int y);
    virtual void HitMap();
    virtual void HitShip(class ShipObj *);
    virtual void Destroy() { }
    virtual void Tick(unsigned);

    void  Init();
    void  Accel();
    void  Impact(Object *, int extra=0, int mul=0, int div=0, bool notland=true);
    void  Shoot();
    void  CtlFire(GunPos gun, bool on);
    void  SetWeps(WepType gun, WepType spec);
    void  AddFlame();
    GunPos FindWep(WepType wt);

    int   IsOnBase()
    { return g_World.IsOnBase((int)Pos.X, (int)Pos.Y);
    }

    GameLib::Vector<FLOAT> OldPos;
    WepBase *Gun, *Special;
    int      Health, Fuel, MaxHealth, MaxFuel, Flash, TurnAcc, nGun, nSpecial;
    bool     bAlive;

  private:
    GameLib::Vertex2D MakeVertex(GameLib::Vector<FLOAT> &v, int x, int y)
    { GameLib::Vertex2D ret((int)v.X+(int)Pos.X-x, (int)v.Y+(int)Pos.Y-y);
      return ret;
    }
    GameLib::Vertex2DC MakeVertex(GameLib::Vector<FLOAT> &v, int x, int y, byte c)
    { GameLib::Vertex2DC ret((int)v.X+(int)Pos.X-x, (int)v.Y+(int)Pos.Y-y, c);
      return ret;
    }
};

class DeadShipObj : public ShipObj
{ public:
    virtual Object * Clone(MsgNewObject *msg);
    virtual void Destroy()  { delete this; }
    virtual void HitObject(Object *o) { o->HitShip(this); }
    virtual void Tick(unsigned tick);

    void LoadShip(ShipObj *);

    struct DStruct
    { int Health;
    };
};

#endif
