#ifndef DEFINES_H_INC
#define DEFINES_H_INC

#define VERMAJOR          0
#define VERMINOR          501

#define GAMECLASS         _T("tchase")
#define GAMETITLE         _T("Triangle Chase")
#define GAMEVER           _T("0.50a")
#define COMPDATE          (__DATE__" "__TIME__)

// raise an error
#define RAISE0(c)         g_Win.Raise(__FILE__, __LINE__, (c))
#define RAISE1(c,v)       g_Win.Raise(__FILE__, __LINE__, (c), (v))
#define RAISE2(c,v,v2)    g_Win.Raise(__FILE__, __LINE__, (c), (v), (v2))
#define RAISE3(c,v,v2,v3) g_Win.Raise(__FILE__, __LINE__, (c), (v), (v2), (v3))

// directory separators for this system
#define DIRSEP            "\\"
#define DIRSEPC           '\\'
#define BASEDATA          ("data" DIRSEP)

#define TICKS_PER_SEC     60
#define FLOAT             float
#define OBJ_KILL_AGE      (TICKS_PER_SEC*30)
#define SHIPSIZE          6

/* COLOR FORMAT -
  Background
    Any color is part of the background
  Foreground
    0       Transparent
    1-191   Collision
    192-223 Passthrough
    224-226 Base
    227-255 Reserved
*/

#define C_HIT(n)  ((n) && (((n)&0xE0) || !((n)&0xC0)))
#define C_BASE(n) ((n)>=224 && (n)<227)
#define C_RES(n)  ((n)>=227)

// reserved colors (edit ResColors in World.cpp too)
enum
{ RC_START=227,
  RC_BLACK=227, RC_DKGREY,    RC_LTGREY,    RC_WHITE,
  RC_DKRED,     RC_RED,       RC_LTRED,     RC_DKGREEN,
  RC_GREEN,     RC_LTGREEN,   RC_DKBLUE,    RC_BLUE,
  RC_LTBLUE,    RC_DKMAGENTA, RC_LTMAGENTA, RC_DKCYAN,
  RC_CYAN,      RC_LTCYAN,    RC_ORANGE,    RC_DKYELLOW,
  RC_YELLOW,    RC_BROWN,     RC_TAN,
  RC_END,       RC_NUM=(RC_END-RC_START)
};

#define NETPORT 4034
#define NETPORTSTR L"4034"

// COM helpers
#define IFS(c) if(SUCCEEDED(hRet=(c)))
#define IFF(c) if(FAILED(hRet=(c)))
#define CHKRET(c, l) if(FAILED(hRet=(c))) goto l;

// sprite positions
#define SPR_CANNONBALL  { 1,  1,  8,  8  }
#define SPR_GRENADE     { 9,  1,  14, 6  }
#define SPR_DROPBOMB    { 15, 1,  20, 5  }
#define SPR_DYNAMITE    { 21, 1,  36, 15 }

#define SPR_EXP1_1      { 37, 1,  42, 6  }
#define SPR_EXP1_2      { 37, 7,  42, 12 }

#define SPR_EXP2_1      SPR_EXP1_1
#define SPR_EXP2_2      { 43, 1,  52, 10 }
#define SPR_EXP2_3      { 53, 1,  62, 10 }

#define SPR_EXP3_1      SPR_EXP1_1
#define SPR_EXP3_2      { 18, 16, 27, 25 }
#define SPR_EXP3_3      { 28, 16, 39, 27 }
#define SPR_EXP3_4      { 40, 16, 51, 27 }
#define SPR_EXP3_5      { 52, 16, 63, 27 }

#define SPR_NULL        { 0, 0, 0, 0 }

#endif
