#include "..\Server\TCServer.h"
#include "..\Precomp.h"

#define RANDS   1024
static Seed, Rands[RANDS];

void wc_cpy(char *buf, const WCHAR *str)
{ WideCharToMultiByte(CP_ACP, 0, str, -1, buf, 100000, NULL, NULL);
}

void wc_cat(char *b, const WCHAR *str)
{ WideCharToMultiByte(CP_ACP, 0, str, -1, b+strlen(b), 100000, NULL, NULL);
}

void cw_cpy(WCHAR *buf, const char *str)
{ MultiByteToWideChar(CP_ACP, 0, str, -1, buf, 100000);
}

void cw_cat(WCHAR *buf, const char *str)
{ MultiByteToWideChar(CP_ACP, 0, str, -1, buf+wcslen(buf), 100000);
}

int g_Trim(char *str)
{ int s=0, e=strlen(str)-1;
  for(;s<=e;s++) if(!isspace(str[s])) break;
  for(;e>s;e--)  if(!isspace(str[e])) break;
  str[++e] = 0;
  if(s) memmove(str, str+s, e-s+1);
  return e-s;
}

// {3DEDC3F6-0434-4d4d-B752-C069BD7C9BFE}
const GUID g_AppGuid = 
{ 0x3dedc3f6, 0x434, 0x4d4d, { 0xb7, 0x52, 0xc0, 0x69, 0xbd, 0x7c, 0x9b, 0xfe } };

#ifndef TCSERVER
Vector<FLOAT> g_Vects[256];

int InitGame()
{ int i;
  g_VFS.Init("data");
  g_AmmoFact.Init();

  for(i=0; i<256; i++)
  { Vector<FLOAT> v = Vector<FLOAT>(0, -1);
    v = v.RotatedZ(i);
    g_Vects[i] = v;
  }

  srand(0xda9908ae);
  for(i=0; i<RANDS; i++) Rands[i] = rand();

  srand(GetTickCount());

  return 0;
}

void g_SRand(unsigned seed)
{ Seed = seed%RANDS;
}

int g_Rand()
{ int ret = Rands[Seed++];
  if(Seed==RANDS) Seed=0;
  return ret;
}

#endif
