#ifndef GLOBALS_H_INC
#define GLOBALS_H_INC

// from Frame\Globals.cpp
// translate between TCHAR and char strings..
void wc_cpy(char *, const WCHAR *);
void wc_cat(char *, const WCHAR *);
void cw_cpy(WCHAR *, const char *);
void cw_cat(WCHAR *, const char *);
int g_Trim(char *str);

extern const GUID g_AppGuid;

// from Utils\VFS.cpp
#include "Utils\VFS.h"
extern CVFS g_VFS;

// from Frame\WinApi.cpp
#include "WinApi.h"
extern CWinApi  g_Win; // access to windows-related stuff

#ifndef TCSERVER
  inline int Round(FLOAT f) { return f<0.0 ? (int)(f-0.5) : (int)(f+0.5); }
  inline FLOAT fabs(FLOAT f) { return f<0.0 ? -f : f; }

  // returns true if x,y is in RECT r
  inline bool PtInRect(RECT *r, int x, int y)
  { return x>=r->left && x<r->right && y>=r->top && y<r->bottom; }

  // from Frame\Globals.cpp
  #include "Utility\Vector.h"
  extern GameLib::Vector<FLOAT> g_Vects[256];
  extern int  InitGame();
  extern void g_SRand(unsigned);
  extern int  g_Rand();

  #include "IntrFace\CDDraw.h"
  #include "IntrFace\CDInput.h"

  // from Frame\Graphics.cpp
  extern GameLib::CDDraw      g_DD;
  extern GameLib::CDDSurface *g_Back;     // the back buffer
  extern GameLib::CDDSurface *g_Sprites;  // the sprite set

  // from Frame\Systems.cpp
  extern GameLib::CDInput     g_Input;
  extern GameLib::CDIKeyboard g_KB;

  // from Engine\Font.cpp
  #include "Engine\Font.h"
  extern CFont g_Fonter;
  extern Font  g_Font;

  // from Engine\World.cpp
  #include "Engine\World.h"
  extern CWorld  g_World;

  // from Engine\GameObj.cpp
  #include "Engine\GameObj.h"
  extern ObjFactory g_ObjFact;

  // from Engine\Ammo.cpp
  #include "Engine\Ammo.h"
  extern AmmoFactory g_AmmoFact;

  // from Engine\Weapons.cpp
  #include "Engine\Weapons.h"
  extern WepFactory  g_WepFact;
  extern const char *g_WepName[WT_NUM];

  // from Frame\Input.cpp
  extern int  g_MouseX, g_MouseY;

  #include "Systems.h"
  // from Frame\Systems.cpp
  extern CSystems g_Sys;      // access to various systems (input,sound,graphics..)

#else

  // from Server\Server.cpp
  #include "..\Server\Server.h"
  extern NetServer g_Server;
#endif

#endif
