#ifndef WINAPI_H_INC
#define WINAPI_H_INC

class CWinApi
{ public:
    CWinApi();
    ~CWinApi();

    int   Init(HINSTANCE hInst);  // initialize the class
    // create a window, widxhei pixels, fullscreen or not
    int   CreateWnd(int wid, int hei, bool fullscreen, bool stdvga);
    // destroy the window
    void  DestroyWnd();

    // attempt to set focus to our window
    void  Focus()
    { assert(hWnd); ::SetForegroundWindow(hWnd); ::SetFocus(hWnd); }

    // pump a single message if one is waiting. return false if we should quit
    bool  Pump();
    // waits for a single message and processes it. also returns false for quit
    bool  WaitMsg();
    // causes the program to quit
    void  Quit();

    // retrieve the command line (including the .exe as the first param)
    const char *CommandLine() { return CmdLine; }
    // get the path to the .exe (ends with a directory separator)
    const char *GetPath() { return ExePath; }

    // open a message box with printf syntax
    void  MsgBox(const char *str, ...) const;
    // open a message box with printf syntax; includes the source file and line
    void  Raise(const char *file, int line, const char *s, ...) const;
    // write something to the debug window with printf syntax
    static void DbgOut(const char *str, ...);

    HWND      hWnd;                 // the window handle
    HINSTANCE hInst;                // the instance handle
    int       Width, Height;        // the width and height passed to CreateWnd()
    bool      bFull, bStdVGA,bFocus,// fullscreen? standard vga? has system focus?
              bMinim;               // minimized?

  private:
    static long CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);

    bool      bRun; // window created and wndproc running?
    char     *ExePath, *CmdLine;
};

#endif
