#include "..\Server\TCServer.h"

void GetLine(char *line, int len)
{ g_Trim(fgets(line, len, stdin));
}

void GetWord(char *word, const char *line)
{ while(*line && !isspace(*line)) *word++=*line++;
  *word=0;
}

bool HandleInput()
{ char line[256], word[256];
  printf("TC> ");

  GetLine(line, 256);
  GetWord(word, line);
  if(!stricmp(word, "load"))
  { g_Trim(line+5);
    if(line[5])
    { printf("Loading %s... ", line+5);
      printf("%s!\n", g_Server.Load(line+5) ? "failed" : "succeeded");
    }
    else puts("Enter a level!");
  }
  else if(!stricmp(word, "host"))
  { printf("Hosting game... ");
    printf("%s!\n", g_Server.Host() ? "failed" : "succeeded");
  }
  else if(!stricmp(word, "close"))
  { printf("Closing game... ");
    g_Server.Close();
    puts("done!");
  }
  else if(!stricmp(word, "help"))
  { puts("  load  level.lev   Loads the given level\n"
         "  host              Causes the server to accept connections\n"
         "  close             Shuts down the game server and kicks all players\n"
         "  help              Prints this message\n"
         "  quit              Quits the program");
    return true;
  }
  else if(!stricmp(word, "quit") || !stricmp(word, "exit")) return false;
  else puts("Unknown command. Try typing HELP.");
  putchar('\n');
  return true;
}

int main()
{ 
#ifndef NDEBUG
  _CrtSetDbgFlag(_CRTDBG_ALLOC_MEM_DF | _CRTDBG_CHECK_ALWAYS_DF |
                 _CRTDBG_LEAK_CHECK_DF);
#endif

  printf("Starting Triangle Chase Server %d.%d%c... ",
         VERMAJOR, VERMINOR/10, VERMINOR%10 ? VERMINOR%10+'a' : ' ');
  g_VFS.Init("data");
  puts("done!");

  while(HandleInput());

  printf("Closing game... ");
  g_Server.Close();
  puts("done!");

  return 0;
}
