#ifndef SERVER_H_INC
#define SERVER_H_INC

#include "..\Network\Network.h"

class NetServer
{ public:
    NetServer();
   ~NetServer();

    int   Init();
    int   Host();
    void  Close();

    int   Load(const char *lev);
    void  Unload();

    void  AddSpawn(int x, int y);
    Player * AddPlayer();
    void  RemPlayer(Player *);
    int   FindPlayer(Player *);
    void  SetName(const char *s);
    void  Lock()   { EnterCriticalSection(&CS); }
    void  Unlock() { LeaveCriticalSection(&CS); }

    int   Send(NetMsg *, Player *, DWORD flags=0, DWORD msTimeout=0);
    int   SendExc(NetMsg *, Player *, DWORD flags=0, DWORD msTimeout=0);

  protected:
    void  AddExp(MsgRemCircles *m);
    void  AddObject(MsgNewObject *);
    void  RemObject(MsgRemObject *);

    unsigned NewID() { unsigned i=NewObjID++; if(!NewObjID) NewObjID=1; return i; }

    IDirectPlay8Server  *pDPS;
    MSGCALL              Call;
    DPNID                dummyPlayer;

    struct Spawn
    { int X, Y;
    };
    Spawn *Spawns;
    int    nSpawns, maxSpawns;

    CircleRem *Circs;
    int        nCircs, maxCircs;

    Player **Players;
    int      nPlayers, maxPlayers;

    MsgNewObject **Objects;
    int            nObjects, maxObjects;

    unsigned NewObjID;

    CRITICAL_SECTION  CS;

    char *Name, Fore[128], Back[128];

    void MsgHandler(Player *, NetMsg *);
    static HRESULT WINAPI Handler(PVOID, DWORD, PVOID);
};

#endif
